Subject: RE: [Ietf-behave] WG last call: draft-ietf-behave-nat-udp-01.txt

From: "Francois Audet" <[email-masked]>
Date: Mon, 9 May 2005 11:02:55 -0700 (PDT)

Hi Paul,

Thank you for your careful reading of the document.

I agree with all your comments and will make the changes accordingly
unless there is opposition on the list.

Cheers.

> -----Original Message-----
> From: ietf-behave-bounces@xxxxxxxxxxxxxxxxxxx 
> [mailto:ietf-behave-bounces@xxxxxxxxxxxxxxxxxxx] On Behalf Of 
> Paul Hoffman
> Sent: Monday, May 09, 2005 10:11
> To: Jiri Kuthan; Ietf-behave@xxxxxxxxxxxxxxxxxxx
> Subject: Re: [Ietf-behave] WG last call: 
> draft-ietf-behave-nat-udp-01.txt
> 
> 
> At 2:10 AM +0200 4/26/05, Jiri Kuthan wrote:
> >This is a BEHAVE Working Group Last Call for comments
> >on draft-ietf-behave-nat-udp-01. This last call closes
> >Tuesday May 12, 2005. Please post any final comments you
> >have on this draft to this list by that date.
> 
> **Unnecessary specification of UDP**
> 
> In a few sentences in the document, UDP is mentioned as if it is the 
> specific protocol being discussed, but TCP could be equivalently 
> substituted in its place. These sentences should be made 
> protocol-agnostic if they really are protocol-agnostic, which I think 
> the following are. (Of course, there are still many UDP-specific 
> sections in the document!)
> 
> 4.1, first sentence, delete "UDP" because the same would be true for 
> "TCP" and possibly other protocols.
> 
> 4.3, first sentence, remove "UDP" because the timers are very 
> unlikely to be different than TCP timers.
> 
> 5.1, first sentence, remove "UDP" because the same would be true for 
> "TCP" and possibly other protocols.
> 
> 7, first sentence, remove "UDP" because the same would be true for 
> "TCP" and possibly other protocols.
> 
> 9, first sentence, remove "UDP" because the same would be true for 
> "TCP" and possibly other protocols.
> 
> 11, first two sentences, remove "UDP" because the same would be true 
> for "TCP" and possibly other protocols.
> 
> 
> **Editorial**
> 
> 1, fourth paragraph, remove "the" and change "off" to "of": 
> "...control off middle boxes..."
> 
> 1, last paragraph, RTP and other UDP-based protocols are said to run 
> on top of UDP, so change "below" to "above".
> 
> 4.2.3, first paragraph, "glare" should be "glaring".
> 
> 5.1, second bullet, replace "...packets to Y..." with "packets to 
> Y:any ..." to make it parallel with the other usage in the section.
> 
> 7, last paragraph, after "methods" add "or protocols that try to be 
> NAT-aware" to make it more general.
> 
> 9, section title should be "ICMP Destination Unreachable Behavior" 
> because that is the only type of ICMP behavior being discussed in the 
> section.
> 
> 10, section title should be "Fragmentation of Outgoing Packets" to 
> emphasize that the entire section is about packets flowing in one 
> direction.
> 
> 10.1, end of first paragraph, add ", or other reasons" because there 
> are many reasons why the MTU is set higher on the NAT.
> 
> 10.1, third and fourth paragraph, "should" needs to be capitalized.
> 
> 10.2, end of first paragraph, add "as specified in" before "RFC 1812".
> 
> 11, first sentence, change "first or last" to "in any fragment" 
> because there may be more than two fragments for the packet.
> 
> 13, last paragraph, add "if done incorrectly" after "...a DoS 
> opportunity" because many stacks correctly buffer fragments in a 
> manner that doesn't make them susceptible.
> 
> 
> --Paul Hoffman, Director
> --Cybersecurity Association 
> _______________________________________________
> Ietf-behave mailing list
> Ietf-behave@xxxxxxxxxxxxxxxxxxx 
> https://list.sipfoundry.org/mailman/listinfo/ietf-behave
> 
>

---

From: "Senthil Sivakumar (ssenthil)" <[email-masked]>
Date: Mon, 9 May 2005 12:04:41 -0700 (PDT)

Comments inline with [Senthil]

-----Original Message-----
From: ietf-behave-bounces@xxxxxxxxxxxxxxxxxxx
[mailto:ietf-behave-bounces@xxxxxxxxxxxxxxxxxxx] On Behalf Of Paul
Hoffman
Sent: Monday, May 09, 2005 11:32 AM
To: Ietf-behave@xxxxxxxxxxxxxxxxxxx
Subject: RE: [Ietf-behave] WG last call:
draft-ietf-behave-nat-udp-01.txt

At 11:13 AM -0700 5/9/05, Senthil Sivakumar \(ssenthil\) wrote:
>A lot of text in this document is generic to both TCP and UDP but the 
>applicability states
>
>"This document only covers the UDP Unicast aspects of NAT traversal and

>does not cover TCP, IPSEC, or other protocols.

There is no mismatch there. In the areas I pointed out, where it says
"UDP" it actually covers any IP-based protocol. Thus, it is better to
keep those parts generic.

[Senthil] To me that is confusing. The text explicitly says no other
protocol is covered but it discusses generic aspects of any IP based
protocol? 

>   Since the document is for UDP only, packet inspection below the UDP 
>layer (including RTP) is also out-of-scope."

There is no mismatch there either. I don't think that the current UDP
requirements draft talks about UDP packet inspection except to say
"don't do that".

>We felt this while writing the TCP behavior draft where we had to refer

>to the UDP draft for generic issues.

Right.

>   The common requirements should be addressed in a seperate document, 
>that will make both the TCP and UDP requirements concise and should not

>be interleaved in this UDP requirements draft.

That's one option. Another is to make the two drafts parallel, pointing
out where they differ due to specific differences between UDP and TCP.

[Senthil] Discussing the specific differences of each of the specific
protocol is what these two drafts are all about. That is not the
problem, the problem is where should the commonlaties reside, in UDP
draft, in TCP draft, in both or in a separate draft. I think it should
reside in a separate draft.

Senthil

--Paul Hoffman, Director

---

From: Pyda Srisuresh <[email-masked]>
Date: Thu, 12 May 2005 07:10:40 -0700 (PDT)

Right, I fully agree with Bryan's comments below

There was no such decision made in the BOF/WG meetings or on the list or in
private e-mails with Cullen, as far as I can recall. Bryan & I had several
e-mail exchanges with Francois & Cullen, authors of the behave-udp draft. Bryan
and I talked about moving out non-UDP-specific stuff into a generic
recommendation draft durign the e-mail discussions and we did a draft on it.
Subsequent to that, I even requested the WG chairs to slot in the behave-gen
draft for the WG meeting in Minneapolis. Had I known a decisin was made to
duplicate all the common material in TCP & UDP drafts or cross reference them
in some ad hoc way, I would, no doubt, have raised this on the list (as I am
doing now).

Here is a request to Jon Peterson, our AD:

As Bryan says below, I suggest we step back a bit and revise the WG milestones.
At the formation of the WG, while milestones are being created, it probably
wasn't obvious that there would be a lot of material common to TCP and UDP. 
Now, it is. I believe, we need to include the  behave-gen draft as one of the
early on milestones. Further, I believe, this is an opportune time to identify
all the drafts that should be adapted as WG drafts and do an overhaul of the
milestones. Thanks.

regards,
suresh

--- Bryan Ford <baford@xxxxxxx> wrote:
> I likewise do not remember any such decision being made, or even discussed on
> 
> the list.  If you're referring to some decision made "somewhere up high in 
> the chain of command" at the very formation of this WG, as you seem to 
> suggest, then that decision was presumably made before any actual text was on
> 
> the table and before any of the technical issues had been explored in depth.
> 
> I do remember seeing a bit of discussion long ago of whether to have two 
> documents (TCP and UDP) or just one big combined document, but _nobody_ here 
> is suggesting just one big document at this point.  The issue here, now, is 
> whether to split the (very considerable) common portions of the TCP and UDP 
> docs out into a common, transport-neutral doc.  The issue is not one document
> 
> versus two, but two documents versus three.
> 
> At the formation of the WG, it probably wasn't obvious that there would be a 
> lot of material common to TCP and UDP, because that material hadn't been 
> written yet.  Now that it's been written, it's become very clear that there 
> is a great deal of common technical requirements, and it would be a 
> structural and readability disaster to duplicate that material across the 
> documents or litter them with ad hoc, ambiguous cross-references.  Given 
> this, it seems highly appropriate to revisit the original decisions on 
> document organization that were made at the formation of the WG.
> 
> Cheers,
> Bryan
> 
> On Tuesday 10 May 2005 20:28, Cullen Jennings wrote:
> > On 5/9/05 7:22 PM, "Pyda Srisuresh" <srisuresh@xxxxxxxxx> wrote:
> > > <... stuff deleted>
> > >
> > >>>>   The common requirements should be addressed in a seperate
> > >>>> document, that will make both the TCP and UDP requirements concise
> > >>>> and should not be interleaved in this UDP requirements draft.
> > >>>
> > >>> That's one option. Another is to make the two drafts parallel,
> > >>> pointing out where they differ due to specific differences between
> > >>> UDP and TCP.
> > >>
> > >> Agree. That decision (to have two parrallel drafts) was already made
> > >
> > > [suresh] When was this decision made? This was neither reviewed nor
> > > decided upon on the list.
> >
> > This was discussed on the list before the BOF. It was discussed in the BOF.
> > It was discussed by ADs and reviewed by IAB and IESG in forming charter. It
> > has been pointed out to you in email from me. It is shown in the milestone
> > section of the Charter page.
> >
> > If there is anything I can do to make it clear I'm glad to do it. If you
> > would like to have another phone call around the reasoning that went into
> > that decision, I am glad to set up a conference call for you and anyone
> > else that cares to join.
> >
> > I'm not sure what else to do.
> >
> > Cullen with my chair hat on.
> >

---

From: "Christian Huitema" <[email-masked]>
Date: Sat, 14 May 2005 00:24:07 -0700 (PDT)

> > I have strong objections to reverse the decision to go
> > ahead with separate documents.
> 
> Are you even LISTENING???  Nobody is proposing to reverse the decision
to
> separate the TCP and UDP documents.  Nobody is proposing to "reverse"
any
> earlier decision at all.  We're basically just proposing to generalize
the
> existing Nov 05 "ICMP" milestone into a "transport-independent
behavior"
> milestone, and bring it forward in the schedule to go alongside the
UDP
> draft.

I have a strong opposition against delaying the publication of an UDP
specific document by trying to build up an artificial "common
requirement" document. There is no consensus that such a document can
even be done, as many NAT implement separate protocols using wholly
separate algorithms. There is also no requirement of any such document
in the charter. If some actually want to issue a common document, they
should do so after we have published the other documents, as a summary.

I support immediate progress of the UDP document.

-- Christian Huitema

---

From: "Christian Huitema" <[email-masked]>
Date: Sun, 15 May 2005 09:14:57 -0700 (PDT)

On May 15, 2005 8:15 AM, at Marc Manthey wrote:

> On May 15, 2005, at 4:26 PM, Pyda Srisuresh wrote:
> 
> >
> > --- Christian Huitema <huitema@xxxxxxxxxxxxxxxxxxxxx> wrote:
> >

The phrase you quote was written by Francois Audet, not me. It was
quoted in Suresh's message, to which I responded.

-- Christian Huitema

---

From: "Francois Audet" <[email-masked]>
Date: Tue, 17 May 2005 14:08:30 -0700 (PDT)

Right: 
we got the same feedback. They wanted a "checklist" type 
section.
<BLOCKQUOTE 
style="PADDING-LEFT: 5px; MARGIN-LEFT: 5px; BORDER-LEFT: #800000 2px solid; MARGIN-RIGHT: 0px">
  
  <FONT 
  face=Tahoma size=2>-----Original Message-----From: Cullen Jennings 
  [mailto:fluffy@xxxxxxxxx] Sent: Tuesday, May 17, 2005 
  10:36To: Audet, Francois [SC100:9T51:EXCH]; 'Paul Hoffman'; 'Bryan 
  Ford'; BehaveSubject: Re: [Ietf-behave] WG last call: 
  draft-ietf-behave-nat-udp-01.txt<FONT 
  face="Verdana, Helvetica, Arial">I don't 
  care deeply, this has been discussed before, I don't see it as really a big 
  deal one way or the other - I will point out that part of the reason it si 
  this way is that residential NAT vendors told us to make a short simple list 
  that they could copy into their requirements document and refer back to RFC 
  for details. This is trying to make that easy for 
  them.  <FONT 
  face="Monaco, Courier New"><SPAN 
style="FONT-SIZE: 10px">